import{S as ft,i as ht,s as _t,e as n,k as c,w as R,t as i,M as gt,c as s,d as o,m,a,x as W,h as l,b as r,G as t,g as p,y as H,L as bt,q as G,o as V,B as j,v as vt}from"../../../chunks/vendor-hf-doc-builder.js";import{D as Je}from"../../../chunks/Docstring-hf-doc-builder.js";import{I as Ke}from"../../../chunks/IconCopyLink-hf-doc-builder.js";function Dt(Qe){let f,te,h,v,J,U,De,K,we,oe,D,ye,T,Ne,ke,ne,C,Ue,se,S,M,Te,x,Me,xe,ae,_,w,Q,$,$e,X,qe,re,u,q,Ee,Y,Ae,Be,E,Ie,z,Oe,Pe,Ce,y,A,Se,B,ze,F,Fe,Le,ie,g,N,Z,I,Re,ee,We,le,b,O,He,P,Ge,L,Ve,je,de;return U=new Ke({}),$=new Ke({}),q=new Je({props:{name:"class diffusers.UNet2DModel",anchor:"diffusers.UNet2DModel",parameters:[{name:"sample_size",val:": typing.Union[int, typing.Tuple[int, int], NoneType] = None"},{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"center_input_sample",val:": bool = False"},{name:"time_embedding_type",val:": str = 'positional'"},{name:"freq_shift",val:": int = 0"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownBlock2D', 'AttnDownBlock2D', 'AttnDownBlock2D', 'AttnDownBlock2D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('AttnUpBlock2D', 'AttnUpBlock2D', 'AttnUpBlock2D', 'UpBlock2D')"},{name:"block_out_channels",val:": typing.Tuple[int] = (224, 448, 672, 896)"},{name:"layers_per_block",val:": int = 2"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"downsample_padding",val:": int = 1"},{name:"downsample_type",val:": str = 'conv'"},{name:"upsample_type",val:": str = 'conv'"},{name:"act_fn",val:": str = 'silu'"},{name:"attention_head_dim",val:": typing.Optional[int] = 8"},{name:"norm_num_groups",val:": int = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"resnet_time_scale_shift",val:": str = 'default'"},{name:"add_attention",val:": bool = True"},{name:"class_embed_type",val:": typing.Optional[str] = None"},{name:"num_class_embeds",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"diffusers.UNet2DModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code> or <code>Tuple[int, int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Height and width of input/output sample. Dimensions must be a multiple of <code>2 ** (len(block_out_channels) - 1)</code>.`,name:"sample_size"},{anchor:"diffusers.UNet2DModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the input sample.",name:"in_channels"},{anchor:"diffusers.UNet2DModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet2DModel.center_input_sample",description:"<strong>center_input_sample</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Whether to center the input sample.",name:"center_input_sample"},{anchor:"diffusers.UNet2DModel.time_embedding_type",description:"<strong>time_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;positional&quot;</code>) &#x2014; Type of time embedding to use.",name:"time_embedding_type"},{anchor:"diffusers.UNet2DModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; Frequency shift for Fourier time embedding.",name:"freq_shift"},{anchor:"diffusers.UNet2DModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to flip sin to cos for Fourier time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.UNet2DModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;DownBlock2D&quot;, &quot;AttnDownBlock2D&quot;, &quot;AttnDownBlock2D&quot;, &quot;AttnDownBlock2D&quot;)</code>) &#x2014;
Tuple of downsample block types.`,name:"down_block_types"},{anchor:"diffusers.UNet2DModel.mid_block_type",description:`<strong>mid_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;UNetMidBlock2D&quot;</code>) &#x2014;
Block type for middle of UNet, it can be either <code>UNetMidBlock2D</code> or <code>UnCLIPUNetMidBlock2D</code>.`,name:"mid_block_type"},{anchor:"diffusers.UNet2DModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;AttnUpBlock2D&quot;, &quot;AttnUpBlock2D&quot;, &quot;AttnUpBlock2D&quot;, &quot;UpBlock2D&quot;)</code>) &#x2014;
Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.UNet2DModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(224, 448, 672, 896)</code>) &#x2014;
Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.UNet2DModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to <code>2</code>) &#x2014; The number of layers per block.",name:"layers_per_block"},{anchor:"diffusers.UNet2DModel.mid_block_scale_factor",description:"<strong>mid_block_scale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014; The scale factor for the mid block.",name:"mid_block_scale_factor"},{anchor:"diffusers.UNet2DModel.downsample_padding",description:"<strong>downsample_padding</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014; The padding for the downsample convolution.",name:"downsample_padding"},{anchor:"diffusers.UNet2DModel.downsample_type",description:`<strong>downsample_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>conv</code>) &#x2014;
The downsample type for downsampling layers. Choose between &#x201C;conv&#x201D; and &#x201C;resnet&#x201D;`,name:"downsample_type"},{anchor:"diffusers.UNet2DModel.upsample_type",description:`<strong>upsample_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>conv</code>) &#x2014;
The upsample type for upsampling layers. Choose between &#x201C;conv&#x201D; and &#x201C;resnet&#x201D;`,name:"upsample_type"},{anchor:"diffusers.UNet2DModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.UNet2DModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to <code>8</code>) &#x2014; The attention head dimension.",name:"attention_head_dim"},{anchor:"diffusers.UNet2DModel.norm_num_groups",description:"<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; The number of groups for normalization.",name:"norm_num_groups"},{anchor:"diffusers.UNet2DModel.norm_eps",description:"<strong>norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-5</code>) &#x2014; The epsilon for normalization.",name:"norm_eps"},{anchor:"diffusers.UNet2DModel.resnet_time_scale_shift",description:`<strong>resnet_time_scale_shift</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;default&quot;</code>) &#x2014; Time scale shift config
for ResNet blocks (see <code>ResnetBlock2D</code>). Choose from <code>default</code> or <code>scale_shift</code>.`,name:"resnet_time_scale_shift"},{anchor:"diffusers.UNet2DModel.class_embed_type",description:`<strong>class_embed_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The type of class embedding to use which is ultimately summed with the time embeddings. Choose from <code>None</code>,
<code>&quot;timestep&quot;</code>, or <code>&quot;identity&quot;</code>.`,name:"class_embed_type"},{anchor:"diffusers.UNet2DModel.num_class_embeds",description:`<strong>num_class_embeds</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Input dimension of the learnable embedding matrix to be projected to <code>time_embed_dim</code> when performing class
conditioning with <code>class_embed_type</code> equal to <code>None</code>.`,name:"num_class_embeds"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unet_2d.py#L40"}}),A=new Je({props:{name:"forward",anchor:"diffusers.UNet2DModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"class_labels",val:": typing.Optional[torch.Tensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet2DModel.forward.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The noisy input tensor with the following shape <code>(batch, channel, height, width)</code>.`,name:"sample"},{anchor:"diffusers.UNet2DModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or <code>int</code>) &#x2014; The number of timesteps to denoise an input.",name:"timestep"},{anchor:"diffusers.UNet2DModel.forward.class_labels",description:`<strong>class_labels</strong> (<code>torch.FloatTensor</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Optional class labels for conditioning. Their embeddings will be summed with the timestep embeddings.`,name:"class_labels"},{anchor:"diffusers.UNet2DModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/models/unet2d#diffusers.models.unet_2d.UNet2DOutput">UNet2DOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unet_2d.py#L228",returnDescription:`
<p>If <code>return_dict</code> is True, an <a
  href="/docs/diffusers/main/en/api/models/unet2d#diffusers.models.unet_2d.UNet2DOutput"
>UNet2DOutput</a> is returned, otherwise a <code>tuple</code> is
returned where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/models/unet2d#diffusers.models.unet_2d.UNet2DOutput"
>UNet2DOutput</a> or <code>tuple</code></p>
`}}),I=new Ke({}),O=new Je({props:{name:"class diffusers.models.unet_2d.UNet2DOutput",anchor:"diffusers.models.unet_2d.UNet2DOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_2d.UNet2DOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
The hidden states output from the last layer of the model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/unet_2d.py#L28"}}),{c(){f=n("meta"),te=c(),h=n("h1"),v=n("a"),J=n("span"),R(U.$$.fragment),De=c(),K=n("span"),we=i("UNet2DModel"),oe=c(),D=n("p"),ye=i("The "),T=n("a"),Ne=i("UNet"),ke=i(" model was originally introduced by Ronneberger et al for biomedical image segmentation, but it is also commonly used in \u{1F917} Diffusers because it outputs images that are the same size as the input. It is one of the most important components of a diffusion system because it facilitates the actual diffusion process. There are several variants of the UNet model in \u{1F917} Diffusers, depending on it\u2019s number of dimensions and whether it is a conditional model or not. This is a 2D UNet model."),ne=c(),C=n("p"),Ue=i("The abstract from the paper is:"),se=c(),S=n("p"),M=n("em"),Te=i("There is large consent that successful training of deep networks requires many thousand annotated training samples. In this paper, we present a network and training strategy that relies on the strong use of data augmentation to use the available annotated samples more efficiently. The architecture consists of a contracting path to capture context and a symmetric expanding path that enables precise localization. We show that such a network can be trained end-to-end from very few images and outperforms the prior best method (a sliding-window convolutional network) on the ISBI challenge for segmentation of neuronal structures in electron microscopic stacks. Using the same network trained on transmitted light microscopy images (phase contrast and DIC) we won the ISBI cell tracking challenge 2015 in these categories by a large margin. Moreover, the network is fast. Segmentation of a 512x512 image takes less than a second on a recent GPU. The full implementation (based on Caffe) and the trained networks are available at "),x=n("a"),Me=i("http://lmb.informatik.uni-freiburg.de/people/ronneber/u-net"),xe=i("."),ae=c(),_=n("h2"),w=n("a"),Q=n("span"),R($.$$.fragment),$e=c(),X=n("span"),qe=i("UNet2DModel"),re=c(),u=n("div"),R(q.$$.fragment),Ee=c(),Y=n("p"),Ae=i("A 2D UNet model that takes a noisy sample and a timestep and returns a sample shaped output."),Be=c(),E=n("p"),Ie=i("This model inherits from "),z=n("a"),Oe=i("ModelMixin"),Pe=i(`. Check the superclass documentation for it\u2019s generic methods implemented
for all models (such as downloading or saving).`),Ce=c(),y=n("div"),R(A.$$.fragment),Se=c(),B=n("p"),ze=i("The "),F=n("a"),Fe=i("UNet2DModel"),Le=i(" forward method."),ie=c(),g=n("h2"),N=n("a"),Z=n("span"),R(I.$$.fragment),Re=c(),ee=n("span"),We=i("UNet2DOutput"),le=c(),b=n("div"),R(O.$$.fragment),He=c(),P=n("p"),Ge=i("The output of "),L=n("a"),Ve=i("UNet2DModel"),je=i("."),this.h()},l(e){const d=gt('[data-svelte="svelte-1phssyn"]',document.head);f=s(d,"META",{name:!0,content:!0}),d.forEach(o),te=m(e),h=s(e,"H1",{class:!0});var ce=a(h);v=s(ce,"A",{id:!0,class:!0,href:!0});var Xe=a(v);J=s(Xe,"SPAN",{});var Ye=a(J);W(U.$$.fragment,Ye),Ye.forEach(o),Xe.forEach(o),De=m(ce),K=s(ce,"SPAN",{});var Ze=a(K);we=l(Ze,"UNet2DModel"),Ze.forEach(o),ce.forEach(o),oe=m(e),D=s(e,"P",{});var me=a(D);ye=l(me,"The "),T=s(me,"A",{href:!0,rel:!0});var et=a(T);Ne=l(et,"UNet"),et.forEach(o),ke=l(me," model was originally introduced by Ronneberger et al for biomedical image segmentation, but it is also commonly used in \u{1F917} Diffusers because it outputs images that are the same size as the input. It is one of the most important components of a diffusion system because it facilitates the actual diffusion process. There are several variants of the UNet model in \u{1F917} Diffusers, depending on it\u2019s number of dimensions and whether it is a conditional model or not. This is a 2D UNet model."),me.forEach(o),ne=m(e),C=s(e,"P",{});var tt=a(C);Ue=l(tt,"The abstract from the paper is:"),tt.forEach(o),se=m(e),S=s(e,"P",{});var ot=a(S);M=s(ot,"EM",{});var pe=a(M);Te=l(pe,"There is large consent that successful training of deep networks requires many thousand annotated training samples. In this paper, we present a network and training strategy that relies on the strong use of data augmentation to use the available annotated samples more efficiently. The architecture consists of a contracting path to capture context and a symmetric expanding path that enables precise localization. We show that such a network can be trained end-to-end from very few images and outperforms the prior best method (a sliding-window convolutional network) on the ISBI challenge for segmentation of neuronal structures in electron microscopic stacks. Using the same network trained on transmitted light microscopy images (phase contrast and DIC) we won the ISBI cell tracking challenge 2015 in these categories by a large margin. Moreover, the network is fast. Segmentation of a 512x512 image takes less than a second on a recent GPU. The full implementation (based on Caffe) and the trained networks are available at "),x=s(pe,"A",{href:!0,rel:!0});var nt=a(x);Me=l(nt,"http://lmb.informatik.uni-freiburg.de/people/ronneber/u-net"),nt.forEach(o),xe=l(pe,"."),pe.forEach(o),ot.forEach(o),ae=m(e),_=s(e,"H2",{class:!0});var ue=a(_);w=s(ue,"A",{id:!0,class:!0,href:!0});var st=a(w);Q=s(st,"SPAN",{});var at=a(Q);W($.$$.fragment,at),at.forEach(o),st.forEach(o),$e=m(ue),X=s(ue,"SPAN",{});var rt=a(X);qe=l(rt,"UNet2DModel"),rt.forEach(o),ue.forEach(o),re=m(e),u=s(e,"DIV",{class:!0});var k=a(u);W(q.$$.fragment,k),Ee=m(k),Y=s(k,"P",{});var it=a(Y);Ae=l(it,"A 2D UNet model that takes a noisy sample and a timestep and returns a sample shaped output."),it.forEach(o),Be=m(k),E=s(k,"P",{});var fe=a(E);Ie=l(fe,"This model inherits from "),z=s(fe,"A",{href:!0});var lt=a(z);Oe=l(lt,"ModelMixin"),lt.forEach(o),Pe=l(fe,`. Check the superclass documentation for it\u2019s generic methods implemented
for all models (such as downloading or saving).`),fe.forEach(o),Ce=m(k),y=s(k,"DIV",{class:!0});var he=a(y);W(A.$$.fragment,he),Se=m(he),B=s(he,"P",{});var _e=a(B);ze=l(_e,"The "),F=s(_e,"A",{href:!0});var dt=a(F);Fe=l(dt,"UNet2DModel"),dt.forEach(o),Le=l(_e," forward method."),_e.forEach(o),he.forEach(o),k.forEach(o),ie=m(e),g=s(e,"H2",{class:!0});var ge=a(g);N=s(ge,"A",{id:!0,class:!0,href:!0});var ct=a(N);Z=s(ct,"SPAN",{});var mt=a(Z);W(I.$$.fragment,mt),mt.forEach(o),ct.forEach(o),Re=m(ge),ee=s(ge,"SPAN",{});var pt=a(ee);We=l(pt,"UNet2DOutput"),pt.forEach(o),ge.forEach(o),le=m(e),b=s(e,"DIV",{class:!0});var be=a(b);W(O.$$.fragment,be),He=m(be),P=s(be,"P",{});var ve=a(P);Ge=l(ve,"The output of "),L=s(ve,"A",{href:!0});var ut=a(L);Ve=l(ut,"UNet2DModel"),ut.forEach(o),je=l(ve,"."),ve.forEach(o),be.forEach(o),this.h()},h(){r(f,"name","hf:doc:metadata"),r(f,"content",JSON.stringify(wt)),r(v,"id","unet2dmodel"),r(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(v,"href","#unet2dmodel"),r(h,"class","relative group"),r(T,"href","https://huggingface.co/papers/1505.04597"),r(T,"rel","nofollow"),r(x,"href","http://lmb.informatik.uni-freiburg.de/people/ronneber/u-net"),r(x,"rel","nofollow"),r(w,"id","diffusers.UNet2DModel"),r(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(w,"href","#diffusers.UNet2DModel"),r(_,"class","relative group"),r(z,"href","/docs/diffusers/main/en/api/models/overview#diffusers.ModelMixin"),r(F,"href","/docs/diffusers/main/en/api/models/unet2d#diffusers.UNet2DModel"),r(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(N,"id","diffusers.models.unet_2d.UNet2DOutput"),r(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(N,"href","#diffusers.models.unet_2d.UNet2DOutput"),r(g,"class","relative group"),r(L,"href","/docs/diffusers/main/en/api/models/unet2d#diffusers.UNet2DModel"),r(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,d){t(document.head,f),p(e,te,d),p(e,h,d),t(h,v),t(v,J),H(U,J,null),t(h,De),t(h,K),t(K,we),p(e,oe,d),p(e,D,d),t(D,ye),t(D,T),t(T,Ne),t(D,ke),p(e,ne,d),p(e,C,d),t(C,Ue),p(e,se,d),p(e,S,d),t(S,M),t(M,Te),t(M,x),t(x,Me),t(M,xe),p(e,ae,d),p(e,_,d),t(_,w),t(w,Q),H($,Q,null),t(_,$e),t(_,X),t(X,qe),p(e,re,d),p(e,u,d),H(q,u,null),t(u,Ee),t(u,Y),t(Y,Ae),t(u,Be),t(u,E),t(E,Ie),t(E,z),t(z,Oe),t(E,Pe),t(u,Ce),t(u,y),H(A,y,null),t(y,Se),t(y,B),t(B,ze),t(B,F),t(F,Fe),t(B,Le),p(e,ie,d),p(e,g,d),t(g,N),t(N,Z),H(I,Z,null),t(g,Re),t(g,ee),t(ee,We),p(e,le,d),p(e,b,d),H(O,b,null),t(b,He),t(b,P),t(P,Ge),t(P,L),t(L,Ve),t(P,je),de=!0},p:bt,i(e){de||(G(U.$$.fragment,e),G($.$$.fragment,e),G(q.$$.fragment,e),G(A.$$.fragment,e),G(I.$$.fragment,e),G(O.$$.fragment,e),de=!0)},o(e){V(U.$$.fragment,e),V($.$$.fragment,e),V(q.$$.fragment,e),V(A.$$.fragment,e),V(I.$$.fragment,e),V(O.$$.fragment,e),de=!1},d(e){o(f),e&&o(te),e&&o(h),j(U),e&&o(oe),e&&o(D),e&&o(ne),e&&o(C),e&&o(se),e&&o(S),e&&o(ae),e&&o(_),j($),e&&o(re),e&&o(u),j(q),j(A),e&&o(ie),e&&o(g),j(I),e&&o(le),e&&o(b),j(O)}}}const wt={local:"unet2dmodel",sections:[{local:"diffusers.UNet2DModel",title:"UNet2DModel"},{local:"diffusers.models.unet_2d.UNet2DOutput",title:"UNet2DOutput"}],title:"UNet2DModel"};function yt(Qe){return vt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Tt extends ft{constructor(f){super();ht(this,f,yt,Dt,_t,{})}}export{Tt as default,wt as metadata};
